structure BinaryTree_Code : sig
  val id : 'a -> 'a
  type 'a equal
  val equal : 'a equal -> 'a -> 'a -> bool
  val eq : 'a equal -> 'a -> 'a -> bool
  datatype inta = Pls | Min | Bit0 of inta | Bit1 of inta |
    Number_of_int of inta
  datatype 'a tree = Tip | T of 'a tree * 'a * 'a tree
  val equal_inta : inta -> inta -> bool
  val equal_int : inta equal
  val less_int : inta -> inta -> bool
  val less_eq_int : inta -> inta -> bool
  val tlookup : ('a -> inta) -> inta -> 'a tree -> 'a option
  val equal_Tree : 'a equal -> 'a tree -> 'a tree -> bool
  val fst : 'a * 'b -> 'a
  val snd : 'a * 'b -> 'b
  val wrmrm : 'a equal -> ('a -> inta) -> 'a tree -> 'a tree * 'a
  val remove : 'a equal -> ('a -> inta) -> 'a -> 'a tree -> 'a tree
  val binsert : ('a -> inta) -> 'a -> 'a tree -> 'a tree
  val test : inta option
end = struct

fun id x = (fn xa => xa) x;

type 'a equal = {equal : 'a -> 'a -> bool};
val equal = #equal : 'a equal -> 'a -> 'a -> bool;

fun eq A_ a b = equal A_ a b;

datatype inta = Pls | Min | Bit0 of inta | Bit1 of inta | Number_of_int of inta;

datatype 'a tree = Tip | T of 'a tree * 'a * 'a tree;

fun equal_inta (Bit1 k1) (Bit1 k2) = equal_inta k1 k2
  | equal_inta (Bit1 k1) (Bit0 k2) = false
  | equal_inta (Bit0 k1) (Bit1 k2) = false
  | equal_inta (Bit0 k1) (Bit0 k2) = equal_inta k1 k2
  | equal_inta (Bit1 k1) Min = equal_inta k1 Min
  | equal_inta (Bit0 k1) Min = false
  | equal_inta (Bit1 k1) Pls = false
  | equal_inta (Bit0 k1) Pls = equal_inta k1 Pls
  | equal_inta Min (Bit1 k2) = equal_inta Min k2
  | equal_inta Min (Bit0 k2) = false
  | equal_inta Min Min = true
  | equal_inta Min Pls = false
  | equal_inta Pls (Bit1 k2) = false
  | equal_inta Pls (Bit0 k2) = equal_inta Pls k2
  | equal_inta Pls Min = false
  | equal_inta Pls Pls = true
  | equal_inta (Number_of_int k) (Number_of_int l) = equal_inta k l;

val equal_int = {equal = equal_inta} : inta equal;

fun less_int (Bit1 k1) (Bit1 k2) = less_int k1 k2
  | less_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_int (Bit0 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit1 k) Min = less_int k Min
  | less_int (Bit0 k) Min = less_eq_int k Min
  | less_int (Bit1 k) Pls = less_int k Pls
  | less_int (Bit0 k) Pls = less_int k Pls
  | less_int Min (Bit1 k) = less_int Min k
  | less_int Min (Bit0 k) = less_int Min k
  | less_int Min Min = false
  | less_int Min Pls = true
  | less_int Pls (Bit1 k) = less_eq_int Pls k
  | less_int Pls (Bit0 k) = less_int Pls k
  | less_int Pls Min = false
  | less_int Pls Pls = false
  | less_int (Number_of_int k) (Number_of_int l) = less_int k l
and less_eq_int (Bit1 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_eq_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit0 k1) (Bit0 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k) Min = less_eq_int k Min
  | less_eq_int (Bit0 k) Min = less_eq_int k Min
  | less_eq_int (Bit1 k) Pls = less_int k Pls
  | less_eq_int (Bit0 k) Pls = less_eq_int k Pls
  | less_eq_int Min (Bit1 k) = less_eq_int Min k
  | less_eq_int Min (Bit0 k) = less_int Min k
  | less_eq_int Min Min = true
  | less_eq_int Min Pls = true
  | less_eq_int Pls (Bit1 k) = less_eq_int Pls k
  | less_eq_int Pls (Bit0 k) = less_eq_int Pls k
  | less_eq_int Pls Min = false
  | less_eq_int Pls Pls = true
  | less_eq_int (Number_of_int k) (Number_of_int l) = less_eq_int k l;

fun tlookup h k Tip = NONE
  | tlookup h k (T (t1, x, t2)) =
    (if less_int k (h x) then tlookup h k t1
      else (if less_int (h x) k then tlookup h k t2 else SOME x));

fun equal_Tree A_ (T (tree1, a, tree2)) Tip = false
  | equal_Tree A_ Tip (T (tree1, a, tree2)) = false
  | equal_Tree A_ (T (tree1a, aa, tree2a)) (T (tree1, a, tree2)) =
    equal_Tree A_ tree1a tree1 andalso
      (eq A_ aa a andalso equal_Tree A_ tree2a tree2)
  | equal_Tree A_ Tip Tip = true;

fun fst (a, b) = a;

fun snd (a, b) = b;

fun wrmrm A_ h (T (t1, x, t2)) =
  (if equal_Tree A_ t2 Tip then (t1, x)
    else (T (t1, x, fst (wrmrm A_ h t2)), snd (wrmrm A_ h t2)));

fun remove A_ h e Tip = Tip
  | remove A_ h e (T (t1, x, t2)) =
    (if less_int (h e) (h x) then T (remove A_ h e t1, x, t2)
      else (if less_int (h x) (h e) then T (t1, x, remove A_ h e t2)
             else (if equal_Tree A_ t1 Tip then t2
                    else let
                           val (t1p, r) = wrmrm A_ h t1;
                         in
                           T (t1p, r, t2)
                         end)));

fun binsert h e Tip = T (Tip, e, Tip)
  | binsert h e (T (t1, x, t2)) =
    (if less_int (h e) (h x) then T (binsert h e t1, x, t2)
      else (if less_int (h x) (h e) then T (t1, x, binsert h e t2)
             else T (t1, e, t2)));

val test : inta option =
  tlookup id (Number_of_int (Bit0 (Bit0 (Bit1 Pls))))
    (remove equal_int id (Number_of_int (Bit1 (Bit1 Pls)))
      (binsert id (Number_of_int (Bit0 (Bit0 (Bit1 Pls))))
        (binsert id (Number_of_int (Bit1 (Bit1 Pls))) Tip)));

end; (*struct BinaryTree_Code*)
