structure BinaryTree_TacticStyle_Code : sig
  datatype inta = Pls | Min | Bit0 of inta | Bit1 of inta |
    Number_of_int of inta
  datatype nat = Zero_nat | Suc of nat
  val less_eq_int : inta -> inta -> bool
  val less_int : inta -> inta -> bool
  val succ : inta -> inta
  val pred : inta -> inta
  val plus_int : inta -> inta -> inta
  val uminus_int : inta -> inta
  val minus_int : inta -> inta -> inta
  val nat_aux : inta -> nat -> nat
  val nat : inta -> nat
  val less_nat : nat -> nat -> bool
  val less_eq_nat : nat -> nat -> bool
  val equal_nat : nat -> nat -> bool
  datatype tree = Tip | Nd of tree * nat * tree
  val equal_tree : tree -> tree -> bool
  val rm : tree -> nat
  val rem : tree -> tree
  val memb : nat -> tree -> bool
  val remove : nat -> tree -> tree
  val binsert : nat -> tree -> tree
  val test : bool
end = struct

datatype inta = Pls | Min | Bit0 of inta | Bit1 of inta | Number_of_int of inta;

datatype nat = Zero_nat | Suc of nat;

fun less_eq_int (Bit1 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_eq_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit0 k1) (Bit0 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k) Min = less_eq_int k Min
  | less_eq_int (Bit0 k) Min = less_eq_int k Min
  | less_eq_int (Bit1 k) Pls = less_int k Pls
  | less_eq_int (Bit0 k) Pls = less_eq_int k Pls
  | less_eq_int Min (Bit1 k) = less_eq_int Min k
  | less_eq_int Min (Bit0 k) = less_int Min k
  | less_eq_int Min Min = true
  | less_eq_int Min Pls = true
  | less_eq_int Pls (Bit1 k) = less_eq_int Pls k
  | less_eq_int Pls (Bit0 k) = less_eq_int Pls k
  | less_eq_int Pls Min = false
  | less_eq_int Pls Pls = true
  | less_eq_int (Number_of_int k) (Number_of_int l) = less_eq_int k l
and less_int (Bit1 k1) (Bit1 k2) = less_int k1 k2
  | less_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_int (Bit0 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit1 k) Min = less_int k Min
  | less_int (Bit0 k) Min = less_eq_int k Min
  | less_int (Bit1 k) Pls = less_int k Pls
  | less_int (Bit0 k) Pls = less_int k Pls
  | less_int Min (Bit1 k) = less_int Min k
  | less_int Min (Bit0 k) = less_int Min k
  | less_int Min Min = false
  | less_int Min Pls = true
  | less_int Pls (Bit1 k) = less_eq_int Pls k
  | less_int Pls (Bit0 k) = less_int Pls k
  | less_int Pls Min = false
  | less_int Pls Pls = false
  | less_int (Number_of_int k) (Number_of_int l) = less_int k l;

fun succ (Bit1 k) = Bit0 (succ k)
  | succ (Bit0 k) = Bit1 k
  | succ Min = Pls
  | succ Pls = Bit1 Pls;

fun pred (Bit1 k) = Bit0 k
  | pred (Bit0 k) = Bit1 (pred k)
  | pred Min = Bit0 Min
  | pred Pls = Min;

fun plus_int (Number_of_int v) (Number_of_int w) = Number_of_int (plus_int v w)
  | plus_int (Bit1 k) (Bit1 l) = Bit0 (plus_int k (succ l))
  | plus_int (Bit1 k) (Bit0 l) = Bit1 (plus_int k l)
  | plus_int (Bit0 k) (Bit1 l) = Bit1 (plus_int k l)
  | plus_int (Bit0 k) (Bit0 l) = Bit0 (plus_int k l)
  | plus_int k Min = pred k
  | plus_int k Pls = k
  | plus_int Min k = pred k
  | plus_int Pls k = k;

fun uminus_int (Number_of_int w) = Number_of_int (uminus_int w)
  | uminus_int (Bit1 k) = Bit1 (pred (uminus_int k))
  | uminus_int (Bit0 k) = Bit0 (uminus_int k)
  | uminus_int Min = Bit1 Pls
  | uminus_int Pls = Pls;

fun minus_int (Number_of_int v) (Number_of_int w) =
  Number_of_int (plus_int v (uminus_int w));

fun nat_aux i n =
  (if less_eq_int i (Number_of_int Pls) then n
    else nat_aux (minus_int i (Number_of_int (Bit1 Pls))) (Suc n));

fun nat i = nat_aux i Zero_nat;

fun less_nat m (Suc n) = less_eq_nat m n
  | less_nat n Zero_nat = false
and less_eq_nat (Suc m) n = less_nat m n
  | less_eq_nat Zero_nat n = true;

fun equal_nat (Suc nat) Zero_nat = false
  | equal_nat Zero_nat (Suc nat) = false
  | equal_nat (Suc nata) (Suc nat) = equal_nat nata nat
  | equal_nat Zero_nat Zero_nat = true;

datatype tree = Tip | Nd of tree * nat * tree;

fun equal_tree (Nd (tree1, nat, tree2)) Tip = false
  | equal_tree Tip (Nd (tree1, nat, tree2)) = false
  | equal_tree (Nd (tree1a, nata, tree2a)) (Nd (tree1, nat, tree2)) =
    equal_tree tree1a tree1 andalso
      (equal_nat nata nat andalso equal_tree tree2a tree2)
  | equal_tree Tip Tip = true;

fun rm (Nd (l, x, r)) = (if equal_tree r Tip then x else rm r);

fun rem (Nd (l, x, r)) = (if equal_tree r Tip then l else Nd (l, x, rem r));

fun memb e Tip = false
  | memb e (Nd (t1, x, t2)) =
    (if less_nat e x then memb e t1
      else (if less_nat x e then memb e t2 else true));

fun remove x Tip = Tip
  | remove x (Nd (l, y, r)) =
    (if less_nat x y then Nd (remove x l, y, r)
      else (if less_nat y x then Nd (l, y, remove x r)
             else (if equal_tree l Tip then r else Nd (rem l, rm l, r))));

fun binsert x Tip = Nd (Tip, x, Tip)
  | binsert x (Nd (t1, y, t2)) =
    (if less_nat x y then Nd (binsert x t1, y, t2)
      else (if less_nat y x then Nd (t1, y, binsert x t2) else Nd (t1, y, t2)));

val test : bool =
  memb (nat (Number_of_int (Bit0 (Bit0 (Bit1 Pls)))))
    (remove (nat (Number_of_int (Bit1 (Bit1 Pls))))
      (binsert (nat (Number_of_int (Bit0 (Bit0 (Bit1 Pls)))))
        (binsert (nat (Number_of_int (Bit1 (Bit1 Pls)))) Tip)));

end; (*struct BinaryTree_TacticStyle_Code*)
